#!/usr/bin/perl

use Text::Wrap;
use Encode;

$file			= "$ENV{HOME}/.conky/tv.xml";
$indent			= " " x $ARGV[0];
$Text::Wrap::columns	= $ARGV[1];
$description		= $ARGV[2];

`wget -O $file "http://www.tampiss.com/rss/tv_online.xml"`;

$skip = 0;
open (FILE, "<:encoding(utf8)", $file);
if ($description eq "no") {
	while (<FILE>) {
		if (m/\<title\>(.*) \> (.{13}) \> ([\S| ]*\S)/){
			print encode_utf8 sprintf("%-5s $2\n", $1);
			print encode_utf8 wrap($indent,$indent, $3."\n");
		}
	}
}
elsif ($description eq "yes") {
	while (<FILE>) {
		if (m/\<title\>(.*) \> (.{13}) \> ([\S| ]*\S)/){
			print encode_utf8 sprintf("%-5s $2\n", $1);
			print encode_utf8 wrap($indent,$indent, $3."\n");
		}
		elsif (m/\<description\>([\S| ]*\S).*\<\/description\>/) {
			if  ($skip == 0) { $skip++ }
			elsif ($1 ne "") {print encode_utf8 wrap($indent,$indent, $1)."\n"};
		} 
	}
}
elsif ($description =~ m/color[0-9]/) {
	while (<FILE>) {
		if (m/\<title\>(.*) \> (.{13}) \> ([\S| ]*\S)/){
			print encode_utf8 sprintf("%-5s $2\n", $1);
			print encode_utf8 wrap($indent,$indent, $3."\n");
		}
		elsif (m/\<description\>([\S| ]*\S).*\<\/description\>/) {
			if  ($skip == 0) { $skip++ }
			elsif ($1 ne "") {print "\$\{$description\}".encode_utf8 wrap($indent,$indent, $1)."\$Color\n"};
		} 
	}
}
close (FILE);
